Create_hist_overlapped <- function(Distr_data_log, bin_width){  
  
  seq_data <- Distr_data_log[!(is.infinite(Distr_data_log))];
  seq_data <- seq_data[!is.na(seq_data)]
  bin_shift <- bin_width*0.5 
  binned_x <- seq(0+bin_width*0.5, max(seq_data, na.rm=TRUE)+bin_width, by = bin_shift)
  binned_data <- rep(c(NA), length(binned_x))
  S <- 0
  num_in_bin <- 0
  for (j in 1:length(binned_x)){
    bin <- binned_x[j];
    for (iter in 1 : length(seq_data)){
      if (seq_data[iter] >= bin - bin_width*0.5 && seq_data[iter] < bin + bin_width/2){ 
        num_in_bin <- num_in_bin + 1      
      }
    }
    binned_data[j] <- num_in_bin
    S = S + bin_width*0.5*num_in_bin
    num_in_bin <- 0    
  }
  binned_y <- binned_data/S
  
  Win <- 3
  f3 <- rep(1/Win,Win)
  binned_y_smoothed <- filter(binned_y, f3, sides=2)
  binned_x <- binned_x[!is.na(binned_y_smoothed)]
  binned_y_smoothed <- binned_y_smoothed[!is.na(binned_y_smoothed)]
  CDF <- sintegral(binned_x, binned_y_smoothed);
  CDF <- list(x=CDF$x, y=CDF$y);  
  PDF <- list(mids=binned_x, density=binned_y_smoothed);   
  output <- list(PDF=PDF, CDF=CDF);
  return(output)
  
}