Main_function <- function(EMatr, bin_width_log, threshold_log_ref, show_ref_distr=FALSE, plotfigs = TRUE){

source("Norm_Lapl_Fit.R")
source("Norm_Lapl_function.R")
source("Norm_Lapl_Transform.R")
source("Truncate_distr.R")
source("Create_hist_overlapped.R")

library(NormalLaplace)
library(data.table)
library(Bolstad2)
library(MESS)
NormTable = c();
PDF_INI_trunc_x = c();

PDF_REF_tr_x <- c();
PDF_INI_trunc_x <- c();
CDF_REF_trunc_y <- c();

ndim = ncol(EMatr);
na_matr <- rep(list(x = rep(c(NA), 100), y = rep(c(NA), 100)), ndim);
Names_genes_below_threshold <- rep(list(x = c(NA), 1))
PDF_INI_full <- na_matr;
PDF_REF_full <- na_matr;
PDF_REF_tr <- na_matr;
PDF_INI_trunc <- na_matr;
PDF_INI_Norm <- na_matr;
PDF_REF_fit <- na_matr;

                         
CDF_INI_trunc <- na_matr;
CDF_REF_trunc <- na_matr;
CDF_INI_full <- na_matr; 
CDF_REF_full <- na_matr; 
CDF_INI_norm <- na_matr; 
norm_coeff_table  <- na_matr;

if(show_ref_distr == TRUE){
  EMatr = rowSums(EMatr);
  EMatr_log_REF <- log(EMatr);
  hist_REF <- Create_hist_overlapped(EMatr_log_REF, bin_width_log)$PDF;
  plot(hist_REF$mids, hist_REF$density, type='l',col='black', xlab="Natural log counts", ylab="Density")
  }else{  
  for (j in 1: ncol(EMatr)){
    ind <- c(j+j-1, j+j);
    Output_data <- Norm_Lapl_Transform(EMatr[, j], EMatr, bin_width_log, threshold_log_ref, fitnum = j); 
    Names_genes_below_threshold[j] <- list( Output_data$Names_genes_below_threshold);
    
    PDF_INI_full[ind] <-list( x=Output_data$PDF_INI_full$x, y=Output_data$PDF_INI_full$y)  
    PDF_REF_fit[ind] <-list( x=Output_data$PDF_REF_fit$x, y=Output_data$PDF_REF_fit$y)    
    PDF_REF_tr[ind] <-list( x=Output_data$PDF_REF_tr$x, y=Output_data$PDF_REF_tr$y)
    PDF_REF_full[ind] <- list(x=Output_data$PDF_REF_full$x, y=Output_data$PDF_REF_full$y) 
    CDF_INI_full[ind] <- list(x=Output_data$CDF_INI_full$x, y=Output_data$CDF_INI_full$y)
    CDF_REF_full[ind] <- list(x=Output_data$CDF_REF_full$x, y=Output_data$CDF_REF_full$y)
    PDF_INI_Norm[ind] <- list(x=Output_data$PDF_INI_Norm$x, y=Output_data$PDF_INI_Norm$y)
    CDF_INI_norm[ind] <- list(x=Output_data$CDF_INI_norm$x, y=Output_data$CDF_INI_norm$y)
    norm_coeff_table[ind] <- list(x=Output_data$norm_coeff_table$x, y=Output_data$norm_coeff_table$y)
    NormTable <- cbind(NormTable, Output_data$table);
    PDF_INI_trunc_x <- cbind(PDF_INI_trunc_x, Output_data$PDF_INI_trunc_x);
    
  }
  Param_ref_fit <- Output_data$Param_ref_fit;
  xlim <- c(0, 12, 0, 0.3) 
  ylim <- c(0, 12, 0, 0.3)  
  
  
  if (plotfigs == TRUE){  
    par(mfrow=c(2,3))
    barplot(colSums(EMatr)*1e-6, main = "Sum of all counts (~Lib depth)", xlab = "Datasets", ylab = "Number of reads, M", names.arg = colnames(EMatr))
    PDF_REF_tr_x <- Output_data$PDF_REF_tr_x;
    
    CDF_REF_trunc_y <- Output_data$CDF_REF_trunc_y;
    plot(PDF_INI_full[c(5, 6)], main = "PDFs before transformation", type='n', xlab = "Natural logarithm of counts", ylab = "Density")  
    for (j in 1:ncol(EMatr)){
      ind <- c(j+j-1, j+j);
      lines(PDF_INI_full[ind], type='l', lwd=1, col='black') 
      lines(PDF_REF_full[ind], type='l', lwd=2, col='red')
      abline(v = c(PDF_INI_trunc_x[ind]), col = "black")
      
    }
    abline(v = c(PDF_REF_tr_x), col = "red")  

    plot(CDF_INI_full[c(1, 2)], type='n', main = "CDFs before transformation", xlab = "Natural logarithm of counts", ylab = "Cumulative distribution")
    for (j in 1:ncol(EMatr)){
      ind <- c(j+j-1, j+j);
      lines(CDF_INI_full[ind], type='l', lwd=1, col='black')  
      lines(CDF_REF_full[ind], type='l', lwd=2, col='red')      
      abline(v = c(PDF_INI_trunc_x[ind]), col = "black")

    }    
    abline(v = c(PDF_REF_tr_x), col = "red")
    
    plot(PDF_REF_tr$x, PDF_REF_tr$y, type='n', main = "Reference PDF fitting", xlab = "Natural logarithm of counts", ylab = "Density")
    lines(PDF_REF_fit[c(1, 2)], type='l', lwd=2, col='red')    
    lines(PDF_REF_tr$x, PDF_REF_tr$y, type='p', col='black')
    
  
    plot(PDF_INI_Norm[c(1, 2)], type='n', main = "PDFs after transformation", xlab = "Natural logarithm of counts", ylab = "Density")
    for (j in 1:ncol(EMatr)){
      ind <- c(j+j-1, j+j);
      lines(PDF_INI_Norm[ind], type='l', lwd=1, col='black')
    } 
    lines(PDF_REF_fit[c(1, 2)], type='l', lwd=2, col='red')#lines(PDF_REF_tr$x, PDF_REF_tr$y, type='l', lwd=2, col='red')
  }   
  colnames(NormTable) <- colnames(EMatr);
  rownames(NormTable) <- rownames(EMatr);  
  return(NormTable) 
}


}